Package: antiProfiles
Maintainer: Hector Corrada Bravo <hcorrada@gmail.com>
Author: Hector Corrada Bravo, Rafael A. Irizarry and Jeffrey T. Leek
Version: 1.50.0
License: Artistic-2.0
Title: Implementation of gene expression anti-profiles
Description: Implements gene expression anti-profiles as described in Corrada
    Bravo et al., BMC Bioinformatics 2012, 13:272 doi:10.1186/1471-2105-13-272.
Depends: R (>= 3.0), matrixStats (>= 0.50.0), methods (>= 2.14), locfit
        (>= 1.5)
URL: https://github.com/HCBravoLab/antiProfiles
biocViews: GeneExpression,Classification
Suggests: antiProfilesData, RColorBrewer
Collate: 'AllClasses.r' 'AllGenerics.r' 'show-methods.r'
        'antiProfiles-package.r' 'ap-methods.r' 'apCounts-methods.r'
        'apReorder-methods.r' 'apStats.r' 'accessors.r' 'ev.R'
RoxygenNote: 5.0.1
git_url: https://git.bioconductor.org/packages/antiProfiles
git_branch: RELEASE_3_22
git_last_commit: bac01fd
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
NeedsCompilation: no
Packaged: 2025-10-30 02:30:44 UTC; biocbuild

setMethod("show",
          signature(object="AntiProfileStats"),
          function(object) {
            cat("AntiProfileStats object on",nrow(object@probes),"probes\n")
            cat("built from",length(object@normalTissues),"normal tissues\n")
            .printHead(object@normalTissues)
            cat("and", length(object@cancerTissues), "cancers types\n")
            .printHead(object@cancerTissues)
            cat("Hypervariability stat:\n")
            show(summary(object@probes$stat))
          })

setMethod("show",
          signature(object="AntiProfile"),
          function(object) {
            cat("AntiProfile object with", length(object@probes),"probes\n")
            cat("Normal medians\n")
            print(summary(object@meds0))
            cat("Using cutoff",object@cutoff,"\n")
          })

setMethod("show",
          signature(object="TissueSpecAntiProfile"),
          function(object) {
            cat("TissueSpecAntiProfile object with", length(object@probes), "probes\n")
            cat("Normal medians\n")
            print(summary(object@meds0))
            cat("Number of tissues\n")
            print(table(sapply(object@theTiss,length)))
            cat("Using cutoff",object@cutoff,"\n")
          })

.printHead <- function(x)
  {
    n <- length(x)
    if (n>20) {
      print(x[1:5])
      cat(n-5, "more elements ...\n")
    } else {
      print(x)
    }
  }

# Accessors for the AntiProfileStats class
#
#' @section Accessors: In the following code \code{object} is a \code{AntiProfileStats} object. \describe{
#'   \item{\code{getProbeStats}:}{Gets probeset statistics. A \code{data.frame} with columns
#'     \describe{
#'        \item{\code{affyid}:}{Affymetrix probeset id (character)}
#'        \item{\code{SD0}:}{Normal expression standard deviation aggregated over tissue types (numeric)}
#'        \item{\code{SD1}:}{Cancer expression standard deviation aggregated over tumor types (numeric)}
#'        \item{\code{stat}:}{The log2-variance ratio statistic (numeric)}
#'        \item{\code{meds0}:}{Median normal expression aggregated over tissue types (numeric)}
#'        \item{\code{mads0}:}{Median absolute deviation of normal expression aggregate over tissue types (numeric)}        
#'    }
#'  }   
#' }
#' 
#' @param object Object of class \code{\linkS4class{AntiProfileStats}}
#' @aliases getProbeStats,AntiProfileStats-method
#' @rdname antiprofilestats-class
#' @export
setMethod(getProbeStats,signature=c(object="AntiProfileStats"),
          function(object) {
            object@probes
          })

# Accessors for the AntiProfile class
#
#' @section Accessors: In the following code \code{object} is a \code{AntiProfile} object. \describe{
#'  \item{\code{getProbesetIds}:}{vector of Affymetrix ids for probesets included in the anti-profile (character)}
#'  \item{\code{getNormalRegions}:}{median and upper boundary of normal expression regions (numeric matrix of dimension s-by-2, where s is the size of the anti-profile)}
#' }
#' 
#' @param object Object of class (or inheriting from) \code{\linkS4class{AntiProfile}}
#' @aliases getProbesetIds,AntiProfile-method
#' @rdname antiprofile-class
#' @export
setMethod(getProbesetIds, signature=c(object="AntiProfile"),
          function(object) {
            object@probes
          })

#' @aliases getNormalRegions,AntiProfile-method
#' @rdname antiprofile-class
#' @export
setMethod(getNormalRegions, signature=c(object="AntiProfile"),
          function(object) {
            out=cbind(object@meds0, object@cutoff * object@mads0)
            dimnames(out)=list(object@probes, c("median","upperBound"))
            out
          })


# Accesors for the TissueSpecAntiProfile class (some inherited from AntiProfile)
#
#' @section Accessors: In the following code \code{object} is a \code{TissueSpecAntiProfile} object. \describe{
#'  \item{\code{getProbesetIds}:}{vector of Affymetrix ids for probesets included in the anti-profile (character)}
#'  \item{\code{getNormalRegions}:}{median and upper boundary of normal expression regions (numeric matrix of dimension s-by-2, where s is the size of the anti-profile)}
#'  \item{\code{getNormalTissueRegions}:}{median and upper boundary of normal expression regions (numeric array of dimension s-by-2-by-t, 
#'  where s is the size of the anti-profile, and t the number of normal tissues used in the anti-profile)}
#' }
#' 
#' @param object Object of class \code{\linkS4class{TissueSpecAntiProfile}}
#' @aliases getProbesetIds,TissueSpecAntiProfile-method getNormalRegions,TissueSpecAntiProfile-method getNormalTissueRegions,TissueSpecAntiProfile-method
#' @rdname tissuespecantiprofile-class
#' @export
setMethod(getNormalTissueRegions, signature=c(object="TissueSpecAntiProfile"),
          function(object) {
            out=array(NA, 
                      dim=c(length(object@probes), 2, ncol(object@tMeds)),
                      dimnames=list(object@probes,c("median","upperBound"),colnames(object@tMeds)))
            for (j in seq(len=ncol(object@tMeds))) {
              out[,,j]=cbind(object@tMeds[,j], object@cutoff*object@tMads[,j])
            }
            out
          })

#' Compute statistics used to construct antiProfile
#'
#' This function calculates normal ranges of expressions and variance ratios for all probesets. To create an anti-profile,
#' call buildAntiProfile on the output of this function
#'
#' @param e matrix of gene expression, with one column per sample
#' @param cl vector of normal/cancer indicators as 0/1
#' @param tiss vector of tissue types for each sample
#' @param minL minimum number of samples of a given tissue/class to compute stats
#' @param cutoff median absolute deviation multiplier used to determine proportion of samples within normal range of expression
#' @param OnCutoff gene expression barcode z-score to determine if a gene is expressed
#' @return An object of class SuccsStats
#'
#'
#' @examples
#'  if (require(antiProfilesData)) {
#'    data(apColonData)
#'    colonStats = apStats(exprs(apColonData), pData(apColonData)$Status)
#'  }
#'
#' @author Hector Corrada Bravo \email{hcorrada@@gmail.com}
#' @seealso \code{\linkS4class{AntiProfileStats}} for the type of object returned. \code{\link{buildAntiProfile}} to construct anti-profiles
#' with objects returned by this function.
#'
#' @export
apStats <- function(e, cl, tiss=NULL, minL=10, cutoff=5, OnCutoff=2.54)
  {
    message("Getting sample indices")
    cIndex0=which(cl==0)
    cIndex1=which(cl==1)

    if (!is.null(tiss)) {
      tIndexes0=split(cIndex0,tiss[cIndex0])
      tIndexes1=split(cIndex1,tiss[cIndex1])
    } else {
      tIndexes0=list(nullTiss=cIndex0)
      tIndexes1=list(nullTiss=cIndex1)
    }

    L0=sapply(tIndexes0,length)
    L1=sapply(tIndexes1,length)

    if (all(L0<minL) || all(L1<minL))
      stop("Not enough samples")

    message("Computing sds")
    sd0=sapply(tIndexes0[L0>=minL],function(ind) return(matrixStats::rowSds(e, cols=ind)))
    sd1=sapply(tIndexes1[L1>=minL],function(ind) return(matrixStats::rowSds(e, cols=ind)))

    SD0=rowMeans(sd0) ##im using mean but we could try median
    SD1=rowMeans(sd1)
    stat=log2(SD1/SD0) ##the statistic

    message("Computing ranges")
    tMeds=sapply(tIndexes0[L0>=minL], function(ind) matrixStats::rowMedians(e, cols=ind))
    tMads=sapply(seq_along(tIndexes0[L0>=minL]), function(i) matrixStats::rowMads(e, cols=tIndexes0[L0>=minL][[i]], center=tMeds[,i]))
    colnames(tMads)=colnames(tMeds)

    meds0=matrixStats::rowMedians(tMeds)
    mads0=matrixStats::rowMedians(tMads)

    message("Computing tissue specificity")
    p0=sapply(tIndexes0[L0>=minL], function(ind) rowMeans(e[,ind]>OnCutoff))
    p1=sapply(tIndexes1[L1>=minL], function(ind) rowMeans(e[,ind]>OnCutoff))

    message("Computing normal tissue outside ranges")
    xx <- .succify(e,meds0,mads0,cutoff)
    tProps0 <- sapply(tIndexes0[L0>=minL], function(ind) rowMeans(xx[,ind]))
    tProps1 <- sapply(tIndexes1[L1>=minL], function(ind) rowMeans(xx[,ind]))

    message("Making probe data frame")
    probes=data.frame(affyid=rownames(e),
      SD0=SD0,SD1=SD1,stat=stat,
      meds0=meds0,mads0=mads0,
      stringsAsFactors=FALSE)

    o=order(-probes$stat)
    new("AntiProfileStats",
        probes=probes[o,],
        normalTissues=names(tIndexes0),
        cancerTissues=names(tIndexes1),
        call=match.call(),
        sd0=sd0[o,,drop=FALSE],
        sd1=sd1[o,,drop=FALSE],
        p0=p0[o,,drop=FALSE],
        p1=p1[o,,drop=FALSE],
        tMeds=tMeds[o,,drop=FALSE],
        tMads=tMads[o,,drop=FALSE],
        tProps0=tProps0[o,,drop=FALSE],
        tProps1=tProps1[o,,drop=FALSE])
  }

#' @rdname apCount-methods
#' @aliases apCount,AntiProfile,matrix-method
setMethod("apCount",
          signature(fit="AntiProfile",
                    expr="matrix"),
          function(fit, expr, ...)
          {
            expr <- expr[fit@probes,]
            colSums(.succify(expr,fit@meds0,fit@mads0,fit@cutoff))
          })

.countTissSpec <- function(fit, expr, ...)
  {
    expr <- expr[fit@probes,]
    xx1 <- .succify(expr,fit@meds0,fit@mads0,fit@cutoff)
    
    nTiss <- sapply(fit@theTiss, length)
    tissIndexes <- split(seq_along(nTiss), nTiss)

    for (ii in 2:length(tissIndexes)) {
      curIndexes <- unlist(tissIndexes[ii:length(tissIndexes)])
      curtIndexes <- cbind(curIndexes, sapply(fit@theTiss[curIndexes], "[", ii-1))
      xx2 <- .succify(expr[curIndexes,], fit@tMeds[curtIndexes], fit@tMads[curtIndexes], fit@cutoff)
      xx1[curIndexes,] <- xx1[curIndexes,] & xx2
    }
    
    colSums(xx1)
  }

#' @rdname apCount-methods
#' @aliases apCount,TissueSpecAntiProfile,matrix-method
setMethod("apCount",
          signature(fit="TissueSpecAntiProfile",
                    expr="matrix"), .countTissSpec)


.succify <- function(e, meds, mads, cutoff) abs(e-meds)/mads>cutoff

#' Statistics used to build anti-profiles
#' 
#' This class stores statistics required to build anti-profiles. 
#' Objects of this class should be built using the \code{\link{apStats}} function. 
#' To build anti-profiles from objects of this class, use the \code{\link{buildAntiProfile}} function.
#' 
#' @section FIXME:
#' ## usage
#' ## Accessors
#' getProbeStats(object)
#' 
#' @seealso \code{\link{apStats}} to construct objects of this class, \code{\link{buildAntiProfile}} to build anti-profiles from objects of this class.
#' 
#' @name AntiProfileStats-class
#' @rdname antiprofilestats-class
#' @author Hector Corrada Bravo \email{hcorrada@@gmail.com}
#' @examples
#' if (require(antiProfilesData)) { 
#'    data(apColonData)
#'    colonStats = apStats(exprs(apColonData), pData(apColonData)$Status)
#'    show(getProbeStats(colonStats))
#'  }
#' 
#' @export
setClass("AntiProfileStats",
         representation=representation(probes="data.frame",
           normalTissues="character",
           cancerTissues="character",
           call="call",
           sd0="matrix",
           sd1="matrix",
           p0="matrix",
           p1="matrix",
           tMeds="matrix",
           tMads="matrix",
           tProps0="matrix",
           tProps1="matrix"))

#' A gene expression anti-profile
#' 
#' This class encapsulates anti-profiles. 
#' Objects of this class should be built from \code{\linkS4class{AntiProfileStats}} objects using the \code{\link{buildAntiProfile}} method.
#' Anti-profile scores can be computed for new samples using the \code{\link{apCount}} method.
#' 
#' @section FIXME:
#' ## usage
#' ## Accessors
#' 
#' getProbesetIds(object)
#' getNormalRegions(object)
#' 
#' @seealso \code{\linkS4class{AntiProfileStats}} for the class of objects from which anti-profiles are built. \cite{\link{buildAntiProfile}}
#' for the method used to construct objects of this class. \code{\link{apCount}} for the function used to calculate anti-profile scores from
#' objects of this class.
#' 
#' @author Hector Corrada Bravo \email{hcorrada@@gmail.com}
#' @examples
#'   if (require(antiProfilesData)) {
#'     data(apColonData)
#'     colonStats=apStats(exprs(apColonData), pData(apColonData)$Status)
#'     colonAP = buildAntiProfile(colonStats, tissueSpec=FALSE, sigsize=10)
#'     show(colonAP)
#'     
#'     head(getProbesetIds(colonAP))
#'     head(getNormalRegions(colonAP))
#'   }
#' @name AntiProfile-class
#' @rdname antiprofile-class
#' 
#' @export
setClass("AntiProfile",
         representation=representation(probes="character",
           meds0="numeric",
           mads0="numeric",
           cutoff="numeric",
           filterFunc="character"))

#' A gene expression anti-profile using tissue-specific regions
#'
#' This class encapsulates anti-profiles with tissue-specific normal expression regions. 
#' Objects of this class should be built from \code{\linkS4class{AntiProfileStats}} objects using the \code{\link{buildAntiProfile}} method.
#' Anti-profile scores can be computed for new samples using the \code{\link{apCount}} method.
#' 
#' @section FIXME:
#' ## usage
#' ## Accessors
#' 
#' getProbesetIds(object)
#' getNormalRegions(object)
#' getNormalTissueRegions(object)
#' 
#'   @seealso \code{\linkS4class{AntiProfileStats}} for the class of objects from which anti-profiles are built. \cite{\link{buildAntiProfile}}
#'   for the method used to construct objects of this class. \code{\link{apCount}} for the function used to calculate anti-profile scores from
#'   objects of this class.
#'                                                                                                                                                                                                                                                                                                                                                                                                                                                                              #' @author Hector Corrada Bravo \email{hcorrada@@gmail.com}
#' @examples 
#'   if (require(antiProfilesData)) {
#'     data(apColonData)
#'     # fake tissues
#'     tissue=rep(c("colon","lung"), len=length(sampleNames(apColonData)))
#'     tissStats=apStats(exprs(apColonData), pData(apColonData)$Status, tiss=tissue, minL=3)
#'     tissAP=buildAntiProfile(tissStats, sigsize=10)
#'     show(tissAP)
#'     
#'     head(getProbesetIds(tissAP))
#'     head(getNormalRegions(tissAP))
#'     head(getNormalTissueRegions(tissAP))
#'   }   
#' @name TissueSpecAntiProfile-class
#' @rdname tissuespecantiprofile-class
#' @export
setClass("TissueSpecAntiProfile",
         contains="AntiProfile",
         representation=representation(tMeds="matrix",
           tMads="matrix",
           theTiss="list"))

#' Compute expression variability measure
#' 
#' This function computes expression variability in a way that
#' removes dependence on mean expression.
#' It uses a local polynomial likelihood method to estimate variance
#' as gamma distributed around given mean expression for each probeset.
#' This function makes this calculation using all samples in argument. To
#' calculate expression variability for samples in different groups, call this
#' function for each subset of columns separately.
#'
#' @param x matrix of gene expression, with one column per sample
#' @param cutoff minimum expression value to be included in computation (for \code{frma} normalized data, we find 2.54 to be a good value for determining if a probeset is expressed in a given sample (default NULL)
#' @param plot make a plot of local likelihood model using \code{smoothScatter} (default=FALSE)
#' @param ... arguments passed to \code{smoothScatter}
#'
#' @return numeric vector of length equal to number of rows of \code{x}
#'
#' @examples
#' if (require(antiProfilesData)) {
#'   data(apColonData)
#'   e <- exprs(apColonData)[,pData(apColonData)$Status==1]
#'   ev <- ev(e, cutoff=2.54)
#' }
#'
#' @author Hector Corrada Bravo \email{hcorrada@@gmail.com}
#' @seealso \code{frma} for normalization
#'
#' @references E. Alemu, H. Corrada Bravo, S. Hannenhalli (2014). Determinants of Expression Variability. Nucleic Acids Research, 42 (6), 3503-14.
#' @export
ev <- function(x, cutoff=NULL, plot=FALSE, ...) {
  if (!is.matrix(x) || !is.numeric(x)) {
    stop("argument 'x' must be a numeric matrix") 
  }

  if (!is.null(cutoff)) {
    if (!is.numeric(cutoff)) {
      stop("argument 'cutoff' must be numeric")
    }

    x[x<cutoff] <- NA
  }
  
  mns <- rowMeans(x, na.rm=TRUE)
  sds <- matrixStats::rowSds(x, na.rm=TRUE)

  drop <- is.na(sds) & is.na(mns)
  mns <- mns[!drop]
  sds <- sds[!drop]
  
  fit <- locfit(sds^2 ~ lp(mns), family="gamma")
  expSd <- sqrt(predict(fit, mns))

  ev <- rep(NA, nrow(x))
  ev[!drop] <- log2(sds) - log2(expSd)

  if (plot) {
    smoothScatter(mns, sds, xlab="mean expression", ylab="std. dev. expression", ...)
    f1 <- function(x) sqrt(predict(fit,x))
    curve(f1, from=min(mns), to=max(mns), col="red", add=TRUE)
  }
  ev
}

#' @export
setGeneric("getProbeStats",
           function(object) standardGeneric("getProbeStats"),
           signature=c("object"))

#' @export
setGeneric("getProbesetIds",
           function(object) standardGeneric("getProbesetIds"),
           signature=c("object"))

#' @export
setGeneric("getNormalRegions",
           function(object) standardGeneric("getNormalRegions"),
           signature=c("object"))

#' @export
setGeneric("getNormalTissueRegions",
           function(object) standardGeneric("getNormalTissueRegions"),
           signature=c("object"))

#' Create an anti-profile from a AntiProfileStats object
#' 
#' This function creates anti-profile using statistics stored in a AntiProfileStats object
#' 
#' @param stats an object of class AntiProfileStats as produced by the apStats function
#' @param tissueSpec use tissue-specific regions of normal expression 
#' @param tissueFilter use only tissue-specific genes in the anti-profile
#' @param sigsize desired size of signature, if NULL, computed from statCutoff
#' @param cutoff median absolute deviation multiplier used to define normal regions of expression
#' @param statCutoff cutoff used to include probesets in anti-profile
#' @return an object of class AntiProfilesSig or AntiProfilesTissueSig depending on the tissueSpec argument
#' 
#' @examples 
#' if (require(antiProfilesData)) {
#'   # create an anti-profile, ignoring tissue-specificity of probesets, with 10 probesets
#'   data(apColonData)
#'   colonStats = apStats(exprs(apColonData), pData(apColonData)$Status)
#'   ap = buildAntiProfile(colonStats, tissueSpec=FALSE, sigsize=10)
#' } 
#' 
#' @author Hector Corrada Bravo \email{hcorrada@@gmail.com}
#'   
#' @export
#' @docType methods
#' @rdname buildAntiProfile-methods
setGeneric("buildAntiProfile",
           function(stats, tissueSpec=TRUE, ...) standardGeneric("buildAntiProfile"),
           signature=c("stats"))

#' Obtain the anti-profile score for a set of samples
#' 
#' This function applies the given anti-profile to a new set of samples. Rownames in the expression matrix
#' are used to match probenames in the AntiProfile object.
#' 
#' @param fit an object of class AntiProfile as produced by the buildAntiProfile method
#' @param expr a matrix of gene expression, rownames are used as identifiers
#' @return a numeric vector of anti-profile scores
#' 
#' @examples 
#'   if (require(antiProfilesData)) {
#'     data(apColonData)
#'   
#'     # compute statistics
#'     colonStats = apStats(exprs(apColonData), pData(apColonData)$Status)
#'   
#'     # create an anti-profile, ignoring tissue-specificity of probesets, with 10 probesets
#'     ap = buildAntiProfile(colonStats, tissueSpec=FALSE, sigsize=10)
#'   
#'     # get counts for the original dataset
#'     counts =apCount(ap, exprs(apColonData))
#'  }
#'  
#' @author Hector Corrada Bravo \email{hcorrada@@gmail.com}
#' 
#' @export  
#' @docType methods
#' @rdname apCount-methods
setGeneric("apCount",
           function(fit, expr, ...) standardGeneric("apCount"),
           signature=c("fit", "expr"))

#' Reorder an AntiProfileStats object
#' 
#' Reorders given AntiProfileStats object using provided ordering o
#' 
#'
#' @param stats An object of class AntiProfileStats
#' @param o A numeric vector giving new probe ordering
#' @return A reordered AntiProfileStats object
#' 
#' @examples 
#' if (require(antiProfilesData)) {
#'   data(apColonData)
#'   colonStats = apStats(exprs(apColonData), pData(apColonData)$Status)
#'   o = sample(seq(len=nrow(slot(colonStats,"probes"))))
#'   newStats = apReorder(colonStats, o)
#' } 
#' 
#' @author Hector Corrada Bravo \email{hcorrada@@gmail.com}
#' 
#' @export
#' @docType methods
#' @rdname apReorder-methods
setGeneric("apReorder",
           function(stats, o) standardGeneric("apReorder"),
           signature=c("stats","o"))

#' @rdname buildAntiProfile-methods
#' @aliases buildAntiProfile,AntiProfileStats-method
setMethod("buildAntiProfile", signature(stats="AntiProfileStats"),
          function(stats, tissueSpec=TRUE, tissueFilter=FALSE, sigsize=NULL, cutoff=5, statCutoff=1, ...)
          {
            isHyperVar <- stats@probes$stat>statCutoff

            if (tissueSpec)
              return(.tissueSpecAP(stats, isHyperVar, cutoff, sigsize, ...))
            
            ii=isHyperVar
            if (tissueFilter) {
              ii <- ii & .apTissueSpec(stats, ...)
            }

            stopifnot(sum(ii)>0)
            if (!is.null(sigsize) && sum(ii)>sigsize) {
              ii <- which(ii)[1:sigsize]
            }

            new("AntiProfile",
                probes=stats@probes$affyid[ii],
                meds0=stats@probes$meds0[ii],
                mads0=stats@probes$mads0[ii],
                cutoff=cutoff)
          })

.apTissueSpec <- function(stats, propCutoff=.95, nTiss=3)
  {
    N10 <- rowSums(stats@p0>=propCutoff)
    N10<=nTiss
  }

.tissueSpecAP <- function(stats, isHyperVar, cutoff, sigsize, propCutoff=.95, nTiss=3)
  {
    xx <- stats@p0>=propCutoff
    theTiss <- apply(xx,1,which)
    N10 <- sapply(theTiss,length)
    isTissueSpec <- N10<=nTiss

    ii <- isHyperVar & isTissueSpec
    stopifnot(sum(ii)>0)

    if (!is.null(sigsize) && sum(ii)>sigsize) {
      ii <- which(ii)[1:sigsize]
    }

    new("TissueSpecAntiProfile",
        probes=stats@probes$affyid[ii],
        meds0=stats@probes$meds0[ii],
        mads0=stats@probes$mads0[ii],
        cutoff=5,
        tMeds=stats@tMeds[ii,],
        tMads=stats@tMads[ii,],
        theTiss=theTiss[ii])
  }

#' Gene Expression Anti-profiles
#' 
#' This package implements the anti-profile method of Corrada Bravo et al., BMC Bioinformatics 2012, 13:272 doi:10.1186/1471-2105-13-272.
#' 
#' @author Hector Corrada Bravo \email{hcorrada@@gmail.com}
#'   
#' @name antiProfiles-package
#' @rdname antiProfiles-package
#' @docType package
NULL

#' @rdname apReorder-methods
#' @aliases apReorder,AntiProfileStats,numeric-method
setMethod("apReorder", signature(stats="AntiProfileStats",o="numeric"),
          function(stats, o) {
            new("AntiProfileStats",
                probes=stats@probes[o,],
                normalTissues=stats@normalTissues,
                cancerTissues=stats@cancerTissues,
                call=stats@call,
                sd0=stats@sd0[o,,drop=FALSE],
                sd1=stats@sd1[o,,drop=FALSE],
                p0=stats@p0[o,,drop=FALSE],
                p1=stats@p1[o,,drop=FALSE],
                tMeds=stats@tMeds[o,,drop=FALSE],
                tMads=stats@tMads[o,,drop=FALSE],
                tProps0=stats@tProps0[o,,drop=FALSE],
                tProps1=stats@tProps1[o,,drop=FALSE])
          })

%\VignetteIndexEntry{Introduction to antiProfiles}
%\VignetteDepends{antiProfiles}
%\VignetteDepends{antiProfilesData}
%\VignetteDepends{RColorBrewer}
\documentclass[12pt]{article}

<<options,echo=FALSE,eval=FALSE,results=hide>>=
options(width=70)
@

\SweaveOpts{eps=FALSE,echo=TRUE}

\usepackage{times}
\usepackage{color,hyperref}
\usepackage{fullpage}
\usepackage[numbers]{natbib}
\definecolor{darkblue}{rgb}{0.0,0.0,0.75}
\hypersetup{colorlinks,breaklinks,linkcolor=darkblue,urlcolor=darkblue,
            anchorcolor=darkblue,citecolor=darkblue}
            
\newcommand{\Rcode}[1]{{\texttt{#1}}}
\newcommand{\Rpackage}[1]{{\texttt{#1}}}
\newcommand{\software}[1]{{\texttt{#1}}}
\newcommand{\R}{\software{R}}
\newcommand{\bold}[1]{\textbf{#1}} % Fix for R bibentry

\title{Introduction to antiProfiles}
\author{H\'{e}ctor Corrada Bravo \texttt{hcorrada@gmail.com}}
\date{Modified: March 13, 2013. Compiled: \today}

\begin{document}
\SweaveOpts{concordance=TRUE}

\setlength{\parskip}{1\baselineskip}
\setlength{\parindent}{0pt}

\maketitle

\section*{Introduction}

This package implements the gene expression anti-profiles method in \cite{ap}. Anti-profiles are a new approach for developing cancer genomic signatures that specifically takes advantage of gene expression heterogeneity. They explicitly model increased gene expression variability in cancer to define robust and reproducible gene expression signatures capable of accurately distinguishing tumor samples from healthy controls.

In this vignette we will use the companion \Rpackage{antiProfilesData} package to illustrate some of the analysis in that paper. 

<<libload>>=
# these are libraries used by this vignette
require(antiProfiles)
require(antiProfilesData)
require(RColorBrewer)
@

\section*{Colon cancer expression data}

The \Rpackage{antiProfilesData} package contains expression data from normal colon tissue samples and colon cancer samples from two datasets in the Gene Expression Omnibus, \url{http://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE8671} and \url{http://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE4183}. Probesets annotated to genes within blocks of hypo-methylation in colon cancer defined in \cite{kh}. Let's load the data and take a look at its contents.

<<loaddata>>=
data(apColonData)
show(apColonData)

# look at sample types by experiment and status
table(apColonData$Status, apColonData$SubType, apColonData$ExperimentID)
@

The data is stored as an \Rcode{ExpressionSet}. This dataset contains colon adenomas, benign but hyperplastic growths along with the normal and tumor tissues. Let's remove these from the remaining analysis.

<<dropadenomas>>=
drop=apColonData$SubType=="adenoma"
apColonData=apColonData[,!drop]
@

\section*{Building antiprofiles}

The general anti-profile idea is to find genes with hyper-variable expression in cancer with respect to normal samples and classify new samples as normal vs. cancer based on deviation from a normal expression profile built from normal training samples. Anti-profiles are built using the following general algorithm:

\begin{enumerate}
\item Find candidate differentially variable genes (anti-profile genes): rank by ratio of cancer to normal variance
\item Define region of normal expression for each anti-profile gene: normal median $\pm$ 5 * normal MAD
\item For each sample to classify:
\begin{enumerate}
\item count number of antiProfile genes outside normal expression region (anti-profile score)
\item if score is above threshold, then classify as cancer
\end{enumerate}
\end{enumerate}

We will use data from one of the experiments to train the anti-profile (steps 1 and 2 above) and test it on the data from the other experiment (step 3).

\subsection*{Computing variance ratios}

The first step in building an antiprofile is to calculate the ratio of normal variance to cancer variance. This is done with the \Rcode{apStats} function.

<<getstats>>=
trainSamples=pData(apColonData)$ExperimentID=="GSE4183"
colonStats=apStats(exprs(apColonData)[,trainSamples], 
                   pData(apColonData)$Status[trainSamples],minL=5)
head(getProbeStats(colonStats))
@

We can see how that ratio is distributed for these probesets:

<<plotstat,fig=TRUE,width=4,height=4>>=
hist(getProbeStats(colonStats)$stat, nc=100, 
     main="Histogram of log variance ratio", xlab="log2 variance ratio")
@

\subsection*{Building the anti-profile}

Now we construct the anti-profile by selecting the 100 probesets most hyper-variable probesets

<<buildap>>=
ap=buildAntiProfile(colonStats, tissueSpec=FALSE, sigsize=100)
show(ap)
@

\subsection*{Computing the anti-profile score}

Given the estimated anti-profile, we can get anti-profile scores for a set of testing samples.

<<plotscore,fig=TRUE,width=6,height=5>>=
counts=apCount(ap, exprs(apColonData)[,!trainSamples])
palette(brewer.pal(8,"Dark2"))

# plot in score order
o=order(counts)
dotchart(counts[o],col=pData(apColonData)$Status[!trainSamples][o]+1,
         labels="",pch=19,xlab="anti-profile score", 
         ylab="samples",cex=1.3)
legend("bottomright", legend=c("Cancer","Normal"),pch=19,col=2:1)
@

The anti-profile score measures deviation from the normal expression profile obtained from the training samples. We see in this case that the anti-profile score can distinguish the test samples perfectly based on deviation from the normal profile. 

\bibliographystyle{plain}
\bibliography{antiProfiles}

\section*{SessionInfo}

<<sessionInfo,results=tex,eval=TRUE,echo=FALSE>>=
toLatex(sessionInfo())
@

\end{document}

\name{apStats}
\alias{apStats}
\title{Compute statistics used to construct antiProfile}
\usage{
  apStats(e, cl, tiss = NULL, minL = 10, cutoff = 5,
    OnCutoff = 2.54)
}
\arguments{
  \item{e}{matrix of gene expression, with one column per
  sample}

  \item{cl}{vector of normal/cancer indicators as 0/1}

  \item{tiss}{vector of tissue types for each sample}

  \item{minL}{minimum number of samples of a given
  tissue/class to compute stats}

  \item{cutoff}{median absolute deviation multiplier used
  to determine proportion of samples within normal range of
  expression}

  \item{OnCutoff}{gene expression barcode z-score to
  determine if a gene is expressed}
}
\value{
  An object of class SuccsStats
}
\description{
  This function calculates normal ranges of expressions and
  variance ratios for all probesets. To create an
  anti-profile, call buildAntiProfile on the output of this
  function
}
\examples{
if (require(antiProfilesData)) {
   data(apColonData)
   colonStats = apStats(exprs(apColonData), pData(apColonData)$Status)
 }
}
\author{
  Hector Corrada Bravo \email{hcorrada@gmail.com}
}
\seealso{
  \code{\linkS4class{AntiProfileStats}} for the type of
  object returned. \code{\link{buildAntiProfile}} to
  construct anti-profiles with objects returned by this
  function.
}

\name{TissueSpecAntiProfile-class}
\alias{TissueSpecAntiProfile-class}
\alias{getNormalRegions,TissueSpecAntiProfile-method}
\alias{getNormalTissueRegions}
\alias{getNormalTissueRegions,TissueSpecAntiProfile-method}
\alias{getProbesetIds,TissueSpecAntiProfile-method}
\title{A gene expression anti-profile using tissue-specific regions}
\usage{
  ## Accessors

  \S4method{getProbesetIds}{TissueSpecAntiProfile}(object) 
  \S4method{getNormalRegions}{TissueSpecAntiProfile}(object)
  getNormalTissueRegions(object)
}

\arguments{
  \item{object}{Object of class
  \code{\linkS4class{TissueSpecAntiProfile}}}
}
\description{
  This class encapsulates anti-profiles with
  tissue-specific normal expression regions. Objects of
  this class should be built from
  \code{\linkS4class{AntiProfileStats}} objects using the
  \code{\link{buildAntiProfile}} method. Anti-profile
  scores can be computed for new samples using the
  \code{\link{apCount}} method.
}

\section{Accessors}{
  In the following code \code{object} is a
  \code{TissueSpecAntiProfile} object. \describe{
  \item{\code{getProbesetIds}:}{vector of Affymetrix ids
  for probesets included in the anti-profile (character)}
  \item{\code{getNormalRegions}:}{median and upper boundary
  of normal expression regions (numeric matrix of dimension
  s-by-2, where s is the size of the anti-profile)}
  \item{\code{getNormalTissueRegions}:}{median and upper
  boundary of normal expression regions (numeric array of
  dimension s-by-2-by-t, where s is the size of the
  anti-profile, and t the number of normal tissues used in
  the anti-profile)} }
}
\examples{
if (require(antiProfilesData)) {
    data(apColonData)
    # fake tissues
    tissue=rep(c("colon","lung"), len=length(sampleNames(apColonData)))
    tissStats=apStats(exprs(apColonData), pData(apColonData)$Status, tiss=tissue, minL=3)
    tissAP=buildAntiProfile(tissStats, sigsize=10)
    show(tissAP)

    head(getProbesetIds(tissAP))
    head(getNormalRegions(tissAP))
    head(getNormalTissueRegions(tissAP))
  }
}
\author{
  Hector Corrada Bravo \email{hcorrada@gmail.com}
}
\seealso{
  \code{\linkS4class{AntiProfileStats}} for the class of
  objects from which anti-profiles are built.
  \cite{\link{buildAntiProfile}} for the method used to
  construct objects of this class. \code{\link{apCount}}
  for the function used to calculate anti-profile scores
  from objects of this class.  #'
}

\docType{methods}
\name{apCount}
\alias{apCount}
\alias{apCount,AntiProfile,matrix-method}
\alias{apCount,TissueSpecAntiProfile,matrix-method}
\title{Obtain the anti-profile score for a set of samples}
\arguments{
  \item{fit}{an object of class AntiProfile as produced by
  the buildAntiProfile method}

  \item{expr}{a matrix of gene expression, rownames are
  used as identifiers}
}
\value{
  a numeric vector of anti-profile scores
}
\description{
  This function applies the given anti-profile to a new set
  of samples. Rownames in the expression matrix are used to
  match probenames in the AntiProfile object.
}
\examples{
if (require(antiProfilesData)) {
    data(apColonData)

    # compute statistics
    colonStats = apStats(exprs(apColonData), pData(apColonData)$Status)

    # create an anti-profile, ignoring tissue-specificity of probesets, with 10 probesets
    ap = buildAntiProfile(colonStats, tissueSpec=FALSE, sigsize=10)

    # get counts for the original dataset
    counts =apCount(ap, exprs(apColonData))
 }
}
\author{
  Hector Corrada Bravo \email{hcorrada@gmail.com}
}

\docType{methods}
\name{buildAntiProfile}
\alias{buildAntiProfile}
\alias{buildAntiProfile,AntiProfileStats-method}
\title{Create an anti-profile from a AntiProfileStats object}
\arguments{
  \item{stats}{an object of class AntiProfileStats as
  produced by the apStats function}

  \item{tissueSpec}{use tissue-specific regions of normal
  expression}

  \item{tissueFilter}{use only tissue-specific genes in the
  anti-profile}

  \item{sigsize}{desired size of signature, if NULL,
  computed from statCutoff}

  \item{cutoff}{median absolute deviation multiplier used
  to define normal regions of expression}

  \item{statCutoff}{cutoff used to include probesets in
  anti-profile}
}
\value{
  an object of class AntiProfilesSig or
  AntiProfilesTissueSig depending on the tissueSpec
  argument
}
\description{
  This function creates anti-profile using statistics
  stored in a AntiProfileStats object
}
\examples{
if (require(antiProfilesData)) {
  # create an anti-profile, ignoring tissue-specificity of probesets, with 10 probesets
  data(apColonData)
  colonStats = apStats(exprs(apColonData), pData(apColonData)$Status)
  ap = buildAntiProfile(colonStats, tissueSpec=FALSE, sigsize=10)
}
}
\author{
  Hector Corrada Bravo \email{hcorrada@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ev.R
\name{ev}
\alias{ev}
\title{Compute expression variability measure}
\usage{
ev(x, cutoff = NULL, plot = FALSE, ...)
}
\arguments{
\item{x}{matrix of gene expression, with one column per sample}

\item{cutoff}{minimum expression value to be included in computation (for \code{frma} normalized data, we find 2.54 to be a good value for determining if a probeset is expressed in a given sample (default NULL)}

\item{plot}{make a plot of local likelihood model using \code{smoothScatter} (default=FALSE)}

\item{...}{arguments passed to \code{smoothScatter}}
}
\value{
numeric vector of length equal to number of rows of \code{x}
}
\description{
This function computes expression variability in a way that
removes dependence on mean expression.
It uses a local polynomial likelihood method to estimate variance
as gamma distributed around given mean expression for each probeset.
This function makes this calculation using all samples in argument. To
calculate expression variability for samples in different groups, call this
function for each subset of columns separately.
}
\examples{
if (require(antiProfilesData)) {
  data(apColonData)
  e <- exprs(apColonData)[,pData(apColonData)$Status==1]
  ev <- ev(e, cutoff=2.54)
}

}
\author{
Hector Corrada Bravo \email{hcorrada@gmail.com}
}
\references{
E. Alemu, H. Corrada Bravo, S. Hannenhalli (2014). Determinants of Expression Variability. Nucleic Acids Research, 42 (6), 3503-14.
}
\seealso{
\code{frma} for normalization
}

\name{AntiProfile-class}
\alias{AntiProfile-class}
\alias{getNormalRegions}
\alias{getNormalRegions,AntiProfile-method}
\alias{getProbesetIds}
\alias{getProbesetIds,AntiProfile-method}
\title{A gene expression anti-profile}
\usage{
  ## Accessors

  getProbesetIds(object) 
  getNormalRegions(object)
}

\arguments{
  \item{object}{Object of class (or inheriting from)
  \code{\linkS4class{AntiProfile}}}
}
\description{
  This class encapsulates anti-profiles. Objects of this
  class should be built from
  \code{\linkS4class{AntiProfileStats}} objects using the
  \code{\link{buildAntiProfile}} method. Anti-profile
  scores can be computed for new samples using the
  \code{\link{apCount}} method.
}
\section{Accessors}{
  In the following code \code{object} is a
  \code{AntiProfile} object. \describe{
  \item{\code{getProbesetIds}:}{vector of Affymetrix ids
  for probesets included in the anti-profile (character)}
  \item{\code{getNormalRegions}:}{median and upper boundary
  of normal expression regions (numeric matrix of dimension
  s-by-2, where s is the size of the anti-profile)} }
}
\examples{
if (require(antiProfilesData)) {
    data(apColonData)
    colonStats=apStats(exprs(apColonData), pData(apColonData)$Status)
    colonAP = buildAntiProfile(colonStats, tissueSpec=FALSE, sigsize=10)
    show(colonAP)

    head(getProbesetIds(colonAP))
    head(getNormalRegions(colonAP))
  }
}
\author{
  Hector Corrada Bravo \email{hcorrada@gmail.com}
}
\seealso{
  \code{\linkS4class{AntiProfileStats}} for the class of
  objects from which anti-profiles are built.
  \cite{\link{buildAntiProfile}} for the method used to
  construct objects of this class. \code{\link{apCount}}
  for the function used to calculate anti-profile scores
  from objects of this class.
}

\name{AntiProfileStats-class}
\alias{AntiProfileStats-class}
\alias{getProbeStats}
\alias{getProbeStats,AntiProfileStats-method}
\title{Statistics used to build anti-profiles}
\usage{
  ## Accessors 
  getProbeStats(object)
}

\arguments{
  \item{object}{Object of class
  \code{\linkS4class{AntiProfileStats}}}
}
\description{
  This class stores statistics required to build
  anti-profiles. Objects of this class should be built
  using the \code{\link{apStats}} function. To build
  anti-profiles from objects of this class, use the
  \code{\link{buildAntiProfile}} function.
}

\section{Accessors}{
  In the following code \code{object} is a
  \code{AntiProfileStats} object. \describe{
  \item{\code{getProbeStats}:}{Gets probeset statistics. A
  \code{data.frame} with columns \describe{
  \item{\code{affyid}:}{Affymetrix probeset id (character)}
  \item{\code{SD0}:}{Normal expression standard deviation
  aggregated over tissue types (numeric)}
  \item{\code{SD1}:}{Cancer expression standard deviation
  aggregated over tumor types (numeric)}
  \item{\code{stat}:}{The log2-variance ratio statistic
  (numeric)} \item{\code{meds0}:}{Median normal expression
  aggregated over tissue types (numeric)}
  \item{\code{mads0}:}{Median absolute deviation of normal
  expression aggregate over tissue types (numeric)} } } }
}
\examples{
if (require(antiProfilesData)) {
   data(apColonData)
   colonStats = apStats(exprs(apColonData), pData(apColonData)$Status)
   show(getProbeStats(colonStats))
 }
}
\author{
  Hector Corrada Bravo \email{hcorrada@gmail.com}
}
\seealso{
  \code{\link{apStats}} to construct objects of this class,
  \code{\link{buildAntiProfile}} to build anti-profiles
  from objects of this class.
}

\docType{methods}
\name{apReorder}
\alias{apReorder}
\alias{apReorder,AntiProfileStats,numeric-method}
\title{Reorder an AntiProfileStats object}
\arguments{
  \item{stats}{An object of class AntiProfileStats}

  \item{o}{A numeric vector giving new probe ordering}
}
\value{
  A reordered AntiProfileStats object
}
\description{
  Reorders given AntiProfileStats object using provided
  ordering o
}
\examples{
if (require(antiProfilesData)) {
  data(apColonData)
  colonStats = apStats(exprs(apColonData), pData(apColonData)$Status)
  o = sample(seq(len=nrow(slot(colonStats,"probes"))))
  newStats = apReorder(colonStats, o)
}
}
\author{
  Hector Corrada Bravo \email{hcorrada@gmail.com}
}

\docType{package}
\name{antiProfiles-package}
\alias{antiProfiles-package}
\title{Gene Expression Anti-profiles}
\description{
  This package implements the anti-profile method of
  Corrada Bravo et al., BMC Bioinformatics 2012, 13:272
  doi:10.1186/1471-2105-13-272.
}
\author{
  Hector Corrada Bravo \email{hcorrada@gmail.com}
}
